<?php
	// check this file's MD5 to make sure it wasn't called before
	$prevMD5=@implode('', @file(dirname(__FILE__).'/setup.md5'));
	$thisMD5=md5(@implode('', @file("./updateDB.php")));
	if($thisMD5==$prevMD5){
		$setupAlreadyRun=true;
	}else{
		// set up tables
		if(!isset($silent)){
			$silent=true;
		}

		// set up tables
		setupTable('tms_license', "create table if not exists `tms_license` (   `LicNo` INT not null auto_increment , primary key (`LicNo`), `IssueDate` DATETIME , `ProdNo` INT(11) , `UserNo` INT , `OrderRef` VARCHAR(45) , `Lic` VARCHAR(80) , `LicOptions` VARCHAR(255) , `DevID` CHAR(64) , `Type` CHAR(10) , `Status` CHAR(10) , `ExpDate` DATE , `MaxUsers` INT , `Notes` LONGTEXT ) CHARSET utf8", $silent);
		setupIndexes('tms_license', array('ProdNo','UserNo'));
		setupTable('tms_user', "create table if not exists `tms_user` (   `UserNo` INT not null auto_increment , primary key (`UserNo`), `UserRef` VARCHAR(60) , `Name` VARCHAR(60) , `Company` VARCHAR(60) , `Email` VARCHAR(45) , `Info` LONGTEXT ) CHARSET utf8", $silent);
		setupTable('tms_product', "create table if not exists `tms_product` (   `ProdNo` INT(11) not null auto_increment , primary key (`ProdNo`), `ProdID` VARCHAR(30) , `Desc` VARCHAR(80) , `CurrentVer` VARCHAR(20) , `TrialDays` INT(11) default '10' , `TrialOptions` VARCHAR(255) , `LicOptions` VARCHAR(255) , `OfflineTimeout` INT(11) default '120' , `ActivityTimeout` INT(11) , `Email` VARCHAR(45) , `EmailInstalls` TINYINT(1) default '0' , `EmailUninstalls` TINYINT(1) default '0' , `EmailFeedback` TINYINT(1) default '0' ) CHARSET utf8", $silent);
		setupTable('tms_track', "create table if not exists `tms_track` (   `TrackNo` INT(11) not null auto_increment , primary key (`TrackNo`), `InstallDate` DATETIME , `Location` VARCHAR(255) , `DevID` CHAR(64) , `ProdNo` INT(11) , `Ver` VARCHAR(20) , `LicNo` INT , `InstallLen` CHAR(16) , `FeedbackDate` DATETIME , `Feedback` LONGTEXT , `Name` VARCHAR(60) , `Email` VARCHAR(45) , `TrialStatus` CHAR(10) , `TrialExpDate` DATETIME , `ActiveTime` DATETIME , `Info1` VARCHAR(255) , `Info2` VARCHAR(255) , `Info3` VARCHAR(255) ) CHARSET utf8", $silent);
		setupIndexes('tms_track', array('ProdNo','LicNo'));
		setupTable('tms_settings', "create table if not exists `tms_settings` (   `SettingsNo` INT(11) not null auto_increment , primary key (`SettingsNo`), `EncryptionKeys` LONGTEXT , `LicPassword` CHAR(64) , `DispFeedback` TINYINT(1) , `DispInfo1` TINYINT(1) , `DispInfo2` TINYINT(1) , `DispInfo3` TINYINT(1) , `InfoTitle1` VARCHAR(45) , `InfoTitle2` VARCHAR(45) , `InfoTitle3` VARCHAR(45) ) CHARSET utf8", $silent);


		// save MD5
		if($fp=@fopen(dirname(__FILE__).'/setup.md5', 'w')){
			fwrite($fp, $thisMD5);
			fclose($fp);
		}
	}


	function setupIndexes($tableName, $arrFields){
		if(!is_array($arrFields)){
			return false;
		}

		foreach($arrFields as $fieldName){
			if(!$res=@mysql_query("SHOW COLUMNS FROM `$tableName` like '$fieldName'")){
				continue;
			}
			if(!$row=@mysql_fetch_assoc($res)){
				continue;
			}
			if($row['Key']==''){
				@mysql_query("ALTER TABLE `$tableName` ADD INDEX `$fieldName` (`$fieldName`)");
			}
		}
	}


	function setupTable($tableName, $createSQL='', $silent=true, $arrAlter=''){
		global $Translation;
		ob_start();

		echo "<div style=\"padding: 5px; border-bottom:solid 1px silver; font-family: verdana, arial; font-size: 10px;\">";

		// is there a table rename query?
		if(is_array($arrAlter)){
			$matches=array();
			if(preg_match("/ALTER TABLE `(.*)` RENAME `$tableName`/", $arrAlter[0], $matches)){
				$oldTableName=$matches[1];
			}
		}

		if($res=@mysql_query("select count(1) from `$tableName`")){ // table already exists
			if($row=@mysql_fetch_array($res)){
				echo str_replace("<TableName>", $tableName, str_replace("<NumRecords>", $row[0],$Translation["table exists"]));
				if(is_array($arrAlter)){
					echo '<br />';
					foreach($arrAlter as $alter){
						if($alter!=''){
							echo "$alter ... ";
							if(!@mysql_query($alter)){
								echo "<font color=red>".$Translation["failed"]."</font><br />";
								echo "<font color=red>".$Translation["mysql said"]." ".mysql_error()."</font><br />";
							}else{
								echo "<font color=green>".$Translation["ok"]."</font><br />";
							}
						}
					}
				}else{
					echo $Translation["table uptodate"];
				}
			}else{
				echo str_replace("<TableName>", $tableName, $Translation["couldnt count"]);
			}
		}else{ // given tableName doesn't exist

			if($oldTableName!=''){ // if we have a table rename query
				if($ro=@mysql_query("select count(1) from `$oldTableName`")){ // if old table exists, rename it.
					$renameQuery=array_shift($arrAlter); // get and remove rename query

					echo "$renameQuery ... ";
					if(!@mysql_query($renameQuery)){
						echo "<font color=red>".$Translation["failed"]."</font><br />";
						echo "<font color=red>".$Translation["mysql said"]." ".mysql_error()."</font><br />";
					}else{
						echo "<font color=green>".$Translation["ok"]."</font><br />";
					}

					if(is_array($arrAlter)) setupTable($tableName, $createSQL, false, $arrAlter); // execute Alter queries on renamed table ...
				}else{ // if old tableName doesn't exist (nor the new one since we're here), then just create the table.
					setupTable($tableName, $createSQL, false); // no Alter queries passed ...
				}
			}else{ // tableName doesn't exist and no rename, so just create the table
				echo str_replace("<TableName>", $tableName, $Translation["creating table"]);
				if(!@mysql_query($createSQL)){
					echo "<font color=red>".$Translation["failed"]."</font><br />";
					echo "<font color=red>".$Translation["mysql said"].mysql_error()."</font>";
				}else{
					echo "<font color=green>".$Translation["ok"]."</font>";
				}
			}
		}

		echo "</div>";

		$out=ob_get_contents();
		ob_end_clean();
		if(!$silent){
			echo $out;
		}
	}
?>